package at.gv.egiz.moazs.config;

import at.gv.egiz.moazs.service.MsgService;
import at.gv.egiz.moazs.service.MzsService;
import at.gv.egiz.moazs.util.EndpointFactory;
import at.gv.zustellung.app2mzs.xsd.App2Mzs;
import at.gv.zustellung.msg.xsd.Zuse2AppPortService;
import org.apache.cxf.interceptor.Interceptor;
import org.apache.cxf.message.Message;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.xml.ws.Endpoint;

@Configuration
public class ServicesConfig {

    @Autowired
    private EndpointFactory endpointFactory;

    @Bean
    @Autowired
    public Endpoint msgEndpoint(MsgService msgService,
                                Zuse2AppPortService zuse2app,
                                Interceptor<Message> msgInterceptor
    ) {
        return endpointFactory.create(msgService, zuse2app, "/msg", msgInterceptor);
    }

    @Bean
    @Autowired
    public Endpoint mzsEndpoint(MzsService mzsService, App2Mzs app2mzs) {
        return endpointFactory.create(mzsService, app2mzs, "/mzs");
    }

    @Bean
    public Zuse2AppPortService zuse2App() {
        return new Zuse2AppPortService();
    }

    @Bean
    public App2Mzs app2mzs() {
        return new App2Mzs();
    }

}
